=== debian/changelog ===
postgresql-11 (11.22-9.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 11.
    + Remove tzdata-legacy from build and test dependencies.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 20 Jan 2025 21:54:01 +0100

postgresql-11 (11.22-9) unstable; urgency=medium

  * Cherry-pick tzdata 2025a fix from upstream.

 -- Christoph Berg <myon@debian.org>  Mon, 20 Jan 2025 21:54:01 +0100

postgresql-11 (11.22-8) unstable; urgency=medium

  * Catch plperl output variation with perl 5.40 on unstable.

 -- Christoph Berg <myon@debian.org>  Thu, 31 Oct 2024 17:19:03 +0100

postgresql-11 (11.22-7) unstable; urgency=medium

  * Run regression tests with TZ America/Los_Angeles.

 -- Christoph Berg <myon@debian.org>  Tue, 08 Oct 2024 17:19:32 +0200

postgresql-11 (11.22-6) unstable; urgency=medium

  * Add Build-Profile pkg.postgresql.nollvm to disable JIT.

 -- Christoph Berg <myon@debian.org>  Thu, 19 Sep 2024 12:27:35 +0200

postgresql-11 (11.22-5) unstable; urgency=medium

  * Cherry-pick 400928b83 from master to fix xml build.

 -- Christoph Berg <myon@debian.org>  Tue, 27 Aug 2024 18:04:39 +0200

postgresql-11 (11.22-4) unstable; urgency=medium

  * Fix JIT on s390x using workaround patch from SUSE.

 -- Christoph Berg <myon@debian.org>  Fri, 03 May 2024 14:38:07 +0200

postgresql-11 (11.22-3) unstable; urgency=medium

  [ Christoph Berg ]
  * Backport LLVM version selection logic from 12+.

  [ Michael Banck ]
  * Backport fix for OpenSSL-3.2 from 12+.

 -- Christoph Berg <myon@debian.org>  Tue, 20 Feb 2024 11:07:43 +0100

postgresql-11 (11.22-2) unstable; urgency=medium

  * Restore relocatability of pg_config.

 -- Christoph Berg <myon@debian.org>  Thu, 08 Feb 2024 13:50:22 +0100

postgresql-11 (11.22-1) unstable; urgency=medium

  * New upstream version.

    * This is expected to be the last PostgreSQL release in the 11.X series.
      Users are encouraged to update to a newer release branch soon.

    * Fix handling of unknown-type arguments in DISTINCT "any" aggregate
      functions (Tom Lane)

      This error led to a text-type value being interpreted as an unknown-type
      value (that is, a zero-terminated string) at runtime.  This could result
      in disclosure of server memory following the text value.

      The PostgreSQL Project thanks Jingzhou Fu for reporting this problem.
      (CVE-2023-5868)

    * Detect integer overflow while computing new array dimensions
      (Tom Lane)

      When assigning new elements to array subscripts that are outside the
      current array bounds, an undetected integer overflow could occur in edge
      cases.  Memory stomps that are potentially exploitable for arbitrary
      code execution are possible, and so is disclosure of server memory.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this problem.
      (CVE-2023-5869)

    * Prevent the pg_signal_backend role from signalling background workers
      and autovacuum processes (Noah Misch, Jelte Fennema-Nio)

      The documentation says that pg_signal_backend
      cannot issue signals to superuser-owned processes.  It was able to
      signal these background processes, though, because they advertise a
      role OID of zero.  Treat that as indicating superuser ownership.
      The security implications of cancelling one of these process types
      are fairly small so far as the core code goes (we'll just start
      another one), but extensions might add background workers that are
      more vulnerable.

      Also ensure that the is_superuser parameter is set correctly in such
      processes.  No specific security consequences are known for that
      oversight, but it might be significant for some extensions.

      The PostgreSQL Project thanks Hemanth Sandrana and Mahendrakar
      Srinivasarao for reporting this problem. (CVE-2023-5870)

  * Rebase debian/patches/libpgport-pkglibdir.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Nov 2023 14:50:52 +0100

postgresql-11 (11.21-1) unstable; urgency=medium

  * New upstream version.

    + Disallow substituting a schema or owner name into an extension script if
      the name contains a quote, backslash, or dollar sign (Noah Misch)

      This restriction guards against SQL-injection hazards for trusted
      extensions.

      The PostgreSQL Project thanks Micah Gate, Valerie Woolard, Tim
      Carey-Smith, and Christoph Berg for reporting this problem.
      (CVE-2023-39417)

  * Test-Depend on tzdata-legacy | tzdata (<< 2023c-8).

 -- Christoph Berg <myon@debian.org>  Tue, 08 Aug 2023 10:18:37 +0200

postgresql-11 (11.20-1) unstable; urgency=medium

  * New upstream version.

    + Prevent CREATE SCHEMA from defeating changes in search_path
      (Report and fix by Alexander Lakhin, CVE-2023-2454)

      Within a CREATE SCHEMA command, objects in the prevailing search_path,
      as well as those in the newly-created schema, would be visible even
      within a called function or script that attempted to set a secure
      search_path.  This could allow any user having permission to create a
      schema to hijack the privileges of a security definer function or
      extension script.

    + Enforce row-level security policies correctly after inlining a
      set-returning function (Report by Wolfgang Walther, CVE-2023-2455)

      If a set-returning SQL-language function refers to a table having
      row-level security policies, and it can be inlined into a calling query,
      those RLS policies would not get enforced properly in some cases
      involving re-using a cached plan under a different role. This could
      allow a user to see or modify rows that should have been invisible.

  * Add Romanian debconf translation, mulțumesc Remus-Gabriel Chelu!
  * Fix update-alternatives when doc package is installed stand-alone.


